cd persistence-aware-escape-analysis-src
mvn clean install

for dir in benchmarks/*/; do
    if [[ "$(basename "$dir")" == *_in ]]; then
        name="${dir%_in/}"   # Remove the '_in' suffix
        name="$(basename "$name")"  # Extract only the base name
        echo "Analyzing $name"
        java -Xmx28g -jar persistence-aware-escapeAnalysis-1.0-jar-with-dependencies.jar -safe "$dir" -safeArg "$dir" -in "$dir" -out ../analysis/results-v3/"$name"_out Harness
    elif [[ "$(basename "$dir")" == "xml-tu" ]]; then
    	name="$(basename "$dir")"
        echo "Analyzing $name"
        java -Xmx28g -jar persistence-aware-escapeAnalysis-1.0-jar-with-dependencies.jar -safe "$dir" -safeArg "$dir" -in "$dir"src -out ../analysis/results-v3/"$name"_out Main
    else
    	name="$(basename "$dir")"
        echo "Analyzing $name"
        java -Xmx28g -jar persistence-aware-escapeAnalysis-1.0-jar-with-dependencies.jar -safe "$dir" -safeArg "$dir" -in "$dir"src -out ../analysis/results-v3/"$name"_out Benchmark
    fi
done

cd -

# post processing of results

find analysis/results-v3 -type d -name "sootified" -exec rm -rf {} +

for file in $(find analysis/results-v3 -type f \( -name "escapeInfo.txt" -o -name "rhsInfo.txt" \)); do
    tr ' ' '\n' < "$file" | sort -t'-' -k1,1n -k2,2n | paste -sd '\n' > temp.txt && mv temp.txt "$file"
done

