## 0. Set environment variables

. scripts/envsetup

## 1. Prepare

bash scripts/prepare.sh

## 1.1 extract precomputed results

tar zxvf analysis.tar.gz
tar zxvf vms.tar.gz
tar zxvf exec_logs.tar.gz

## 2. Analysis (analyze HAMT)

# Build analyzer
bash scripts/buildAnalyzer.sh

cd persistence-aware-escape-analysis-src
java -jar persistence-aware-escapeAnalysis-1.0-jar-with-dependencies.jar -safe benchmarks/hamt -safeArg benchmarks/hamt -in "benchmarks/hamt/src" -out ../analysis/results-v3/hamt_out Benchmark 
cd -

find analysis/results-v3 -type d -name "sootified" -exec rm -rf {} +
for file in $(find analysis/results-v3 -type f \( -name "escapeInfo.txt" -o -name "rhsInfo.txt" \)); do
    tr ' ' '\n' < "$file" | sort -t'-' -k1,1n -k2,2n | paste -sd '\n' > temp.txt && mv temp.txt "$file"
done


## 3. Build VM in "vms" (build all-cw-h)

rm -fr vms/all-cw-h
bash scripts/makevms.sh all-cw-h

## 4. Run benchmarking (run HAMT-1)
##    results will be generated in "exec_logs"

bash scripts/run_benchmark.sh -small time HAMT-1 none-original-none
bash scripts/run_benchmark.sh -small time HAMT-1 none-ww-none
bash scripts/run_benchmark.sh -small time HAMT-1 none-cw-none

bash scripts/run_benchmark.sh -small time HAMT-1 all-ww-none
bash scripts/run_benchmark.sh -small time HAMT-1 all-cw-none
bash scripts/run_benchmark.sh -small time HAMT-1 all-cw-h
bash scripts/run_benchmark.sh -small time HAMT-1 all-cwx-none
bash scripts/run_benchmark.sh -small time HAMT-1 all-cwx-h

bash scripts/run_benchmark.sh -small count HAMT-1 none-ww-none
bash scripts/run_benchmark.sh -small count HAMT-1 none-cw-none
bash scripts/run_benchmark.sh -small count HAMT-1 all-ww-none
bash scripts/run_benchmark.sh -small count HAMT-1 all-cw-none
bash scripts/run_benchmark.sh -small count HAMT-1 all-cw-h

## 5. generate graphs

python3 scripts/pick_numbers.py
python3 scripts/count.py -small
python3 scripts/chart.py -small
python3 scripts/chart-handshake.py -small


